SystemOrganization addCategory: #DaliotsLinearAlgebra!

!Number methodsFor: '*DaliotsLinearAlgebra' stamp: 'HwaJong 8/29/2013 18:26'!
addToPolynomial: aPolynomial 

	^Polynomial coefficient: (aPolynomial coefficient copy modifyLast: [:that| that + self ])! !

!Number methodsFor: '*DaliotsLinearAlgebra' stamp: 'HwaJong 8/29/2013 19:17'!
magnitude
	^self abs! !

!Number methodsFor: '*DaliotsLinearAlgebra' stamp: 'HwaJong 8/29/2013 18:23'!
multiplyByPolynomial: aPolynomial 

	^Polynomial coefficient: (aPolynomial coefficient * self)! !

!Number methodsFor: '*DaliotsLinearAlgebra' stamp: 'HwaJong 8/29/2013 15:47'!
subtractFromPolynomial: aPolynomial 

	^aPolynomial coefficient: (aPolynomial coefficient copy modifyLast: [:that| that-self ])! !

!SequenceableCollection methodsFor: '*DaliotsLinearAlgebra' stamp: 'HwaJong 8/29/2013 18:17'!
accumulate: anArray from: anIndex

	"Dolphin: self replaceFrom: anIndex size: (anArray size) with: ((self copyFrom: anIndex size: anArray size) + anArray)"
	self replaceFrom: anIndex to: (anArray size + anIndex - 1) with: ((self copyFrom: anIndex size: anArray size) + anArray) startingAt: 1! !

!SequenceableCollection methodsFor: '*DaliotsLinearAlgebra' stamp: 'HwaJong 8/29/2013 18:19'!
copyFrom: anInteger size: anInteger2 
	^self copyFrom: anInteger to: (anInteger + anInteger2 - 1)! !

!SequenceableCollection methodsFor: '*DaliotsLinearAlgebra' stamp: 'HwaJong 8/29/2013 15:36'!
modifyLast: aBlockClosure 
	self at: self size modify: aBlockClosure ! !

Object subclass: #Polynomial
	instanceVariableNames: 'coefficientVector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DaliotsLinearAlgebra'!

!Polynomial class methodsFor: 'instance creation' stamp: 'HwaJong 8/29/2013 15:30'!
coefficient: aSequencableCollection

	^self new coefficient: aSequencableCollection; yourself.! !

!Polynomial class methodsFor: 'instance creation' stamp: 'HwaJong 8/29/2013 17:02'!
order: anInteger 
	
"anInteger is the order of the new polynomial instance"
	^self coefficient: (Array new: anInteger+1 withAll: 0)! !

!Polynomial class methodsFor: 'instance creation' stamp: 'HwaJong 8/29/2013 18:21'!
root: aNumber

	^Polynomial coefficient: (Array with:1 with: (aNumber negated))! !

!Polynomial class methodsFor: 'instance creation' stamp: 'HwaJong 8/29/2013 18:20'!
roots: aCollection

	|productOfPolynomials|
	productOfPolynomials := Polynomial coefficient: #(1).

	aCollection do: [:root| productOfPolynomials := (self root: root) * productOfPolynomials ].
	^productOfPolynomials! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 16:59'!
* polynomialOrNumber

	^polynomialOrNumber multiplyByPolynomial: self! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 18:24'!
+ numberOrPolynomial

	^numberOrPolynomial addToPolynomial: self! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 15:38'!
- numberOrPolynnomial

	^numberOrPolynnomial subtractFromPolynomial: self! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 15:43'!
= aPolynomial

	^self coefficient = aPolynomial coefficient! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 15:46'!
adaptToNumber: aNumber andSend: aSymbol 
	^(Polynomial coefficient: {aNumber}) perform: aSymbol with: self! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 20:04'!
addToFloat: aFloat 

	^self class coefficient: (self coefficient copy modifyLast: [:that| that + aFloat ])! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 20:05'!
addToFraction: aFraction 

	^self addToFloat: aFraction! !

!Polynomial methodsFor: 'changing' stamp: 'HwaJong 8/29/2013 15:35'!
addToInteger: anInteger 

	^self coefficient: (self coefficient copy modifyLast: [:that| that + anInteger ])! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 18:25'!
addToPolynomial: aPolynomial

	| maxOrder |
	maxOrder := self order max: aPolynomial order.
	^Polynomial coefficient:
		((self order: maxOrder) coefficient + (aPolynomial order: maxOrder) coefficient)! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 15:35'!
coefficient

	^coefficientVector! !

!Polynomial methodsFor: 'changing' stamp: 'HwaJong 8/29/2013 15:32'!
coefficient: aSequenceableCollection

	coefficientVector := aSequenceableCollection.! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 20:08'!
coefficientOfOrder: anInteger

	^coefficientVector at: (coefficientVector size - anInteger)! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 20:10'!
constantTerm

	^self coefficient last! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 19:12'!
derivatived
	
	|newCoefficientVector|
	newCoefficientVector := Array new: self order.
	newCoefficientVector keysAndValuesDo: [:indx :coef | newCoefficientVector at: indx put: ( coefficientVector size - indx) * (coefficientVector at: indx) ].

	^self class coefficient: newCoefficientVector.! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/30/2013 00:29'!
fineRealRoots 

"coefficients are assumed to be real number"
"TODO: complex coefficient case: solve each real poly and imag poly. Merge them to form complex roots"
	| order table roots |
	order := self order.
	(order) < 0 ifTrue: [ ^self error: 'ill polynomial for root finding' ].
	(order) = 0 ifTrue: [ ^self error: 'zero order polynomial has no root'].
	(order) = 1 ifTrue: [ ^OrderedCollection with: ((coefficientVector at:2)/(coefficientVector at:1)) negated ].
	roots := OrderedCollection new.
	table := OrderedCollection new.
	table add: (Float fmax negated @ (((order odd) ifTrue: [-1] ifFalse: [1]) * (self highestCoefficient sign)) ).
	(self derivatived fineRealRoots asSortedCollection) do: [:x| table add: (x@((self value:x) sign))].
	table add: (Float fmax @ ((1) * (self highestCoefficient sign)) ).
	1 to: table size -1 do: [:k|
		|a b|
		a := table at: k.
		b := table at: k+1.
		(a y) = (b y)
			ifFalse: [roots add: (self zeroCrossingRootBetween: a x and: b x)]
		].
	^roots! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 19:14'!
highestCoefficient

	^self coefficient first! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 18:29'!
laguerresRoots

	^RootsOfPolynomialAlgorithm new
		polynomial: self;
		oneRootAlgorithm: (LaguerreAlgorithm new iterationLimit: 100);
		reset;
		runUntil;
		roots! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 9/10/2013 22:17'!
lowestCoefficient

	^self coefficient last! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/30/2013 12:53'!
multiplyByInteger: anInteger 

	^self class coefficient: self coefficient * anInteger! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 17:00'!
multiplyByPolynomial: aPolynomial

	|answerPolynomial|
	answerPolynomial := Polynomial order: self order + aPolynomial order. 

	aPolynomial coefficient keysAndValuesDo: [:indx :value| answerPolynomial coefficient accumulate: (self coefficient * value) from: indx].
	^answerPolynomial! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/30/2013 12:55'!
negated

	^self class coefficient: self coefficient negated! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/30/2013 13:01'!
oneRoot

	"this method will not work."
	| derv track trackValue|
	derv := self derivatived.
	track := (1.0,1.0). "This is Complex creator expression."
	
	[trackValue := self value: track. trackValue = 0] whileFalse: 
	[ 
		track := track - (trackValue/(derv value:track)).
	].
	^track
! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 15:40'!
order

	^coefficientVector size - 1! !

!Polynomial methodsFor: 'changing' stamp: 'HwaJong 8/29/2013 15:42'!
order: anInteger

	(anInteger > self order)
		ifTrue: [^Polynomial coefficient: ((Array new: (anInteger - self order) withAll: 0), coefficientVector) ].
	(anInteger = self order)
		ifTrue: [^self].
	(anInteger < self order)
		ifTrue: [^Polynomial coefficient: (coefficientVector copyFrom: coefficientVector size-anInteger) ].
! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 9/10/2013 22:20'!
powerSeries: aNumber

	| powered stream |
	powered := 1.
	stream := Array writeStream.
	coefficientVector do: [:each| 
		stream nextPut: powered. 
		powered := powered * aNumber ].
	^stream contents reverse! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 19:13'!
quo: aPolynomial

	^(self quoAndRem: aPolynomial) first! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 19:14'!
quoAndRem: aPolynomial

	|quo rem|
	quo := Array new: self order-aPolynomial order+1 withAll: 0.
	rem := self coefficient copy.

	1 to: quo size do:
	[ :i| |p|
		p := (rem at:i) / (aPolynomial highestCoefficient).
		quo at:i put:p.
		rem accumulate: aPolynomial coefficient * p negated from: i
	].
	^Array with: (self class coefficient:quo) with: (self class coefficient: (rem copyLast: aPolynomial order))! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 9/10/2013 22:23'!
raisedTo: aNonnegativeInteger

	|prod|
	prod := self class coefficient: #(1).
	aNonnegativeInteger timesRepeat: [prod := prod * self].
	^prod
! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 9/10/2013 22:31'!
removeHighZeros

	^self class coefficient:
		(self coefficient allButFirst: (self coefficient findFirst: [:coef| coef ~= 0 ]) - 1)! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 18:27'!
roots

	^self laguerresRoots! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 9/10/2013 22:33'!
subtractFromInteger: anInteger 

	^self negated addToInteger: anInteger! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 15:39'!
subtractFromPolynomial: aPolynomial 

	| maxOrder |
	maxOrder := self order max: aPolynomial order.
	^self class coefficient: 
		((aPolynomial order: maxOrder) coefficient - (self order: maxOrder) coefficient)
! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 19:13'!
value: aNumericValue

	^coefficientVector inject: 0 into: [:sum :coeff| (sum * aNumericValue) + coeff ].! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/30/2013 12:44'!
zeroCrossingRootBetween: smallEnd and: bigEnd

	^BinarySearcher new
		left: smallEnd;
		right: bigEnd;
		equation: [:x| self value: x ];
		accuracy: 0.000000000000000001;
		significantXDifference: 1e-14;
		solve! !

Algorithm subclass: #LaguerreAlgorithm
	instanceVariableNames: 'f ff fff x roots polynomial'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DaliotsLinearAlgebra'!

!LaguerreAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:11'!
basicStep

	"Private - Find one root"
	|g h n sqrtPart denom a|

	g := (ff value:x)/(f value:x).
	h := g squared - ((fff value:x)/(f value:x)).

	n := f order.
	sqrtPart := ((n-1)*(n*h-g squared))sqrt.
	(g + sqrtPart) magnitude > (g - sqrtPart) magnitude
		ifTrue: [denom := g + sqrtPart]
		ifFalse: [denom := g - sqrtPart].
	a := n / denom.
	x := x - a.
	^a! !

!LaguerreAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:11'!
okToTerminate

	^(f value:x)=0
! !

!LaguerreAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:11'!
okToTerminateFor: dx

	^dx = 0
! !

!LaguerreAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:11'!
polynomial: aPolynomial

	polynomial := aPolynomial! !

!LaguerreAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:11'!
reset

	super reset.
	f := polynomial.
	ff := f derivatived.
	fff := ff derivatived.
	x := 1.! !

!LaguerreAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:11'!
root

	^x! !

Algorithm subclass: #RootsOfPolynomialAlgorithm
	instanceVariableNames: 'roots polynomial oneRootAlgorithm targetNumberOfRoots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DaliotsLinearAlgebra'!

!RootsOfPolynomialAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:08'!
basicStep

	|root|
	oneRootAlgorithm polynomial: polynomial.
	oneRootAlgorithm reset.
	oneRootAlgorithm run.
	root := oneRootAlgorithm root.
	roots add: root.
	polynomial := polynomial quo: (Polynomial root: root).
	^roots! !

!RootsOfPolynomialAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:08'!
initialize

	super initialize! !

!RootsOfPolynomialAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:08'!
okToTerminateFor: anOrderedCollection 

	^anOrderedCollection size = targetNumberOfRoots! !

!RootsOfPolynomialAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:09'!
oneRootAlgorithm: anAlgorithm

	oneRootAlgorithm := anAlgorithm! !

!RootsOfPolynomialAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:09'!
polynomial: aPolynomial

	polynomial := aPolynomial! !

!RootsOfPolynomialAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:09'!
reset

	super reset.
	roots := OrderedCollection new.
	targetNumberOfRoots := polynomial order.! !

!RootsOfPolynomialAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:09'!
roots

	^roots
! !

TestCase subclass: #PolynomialTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DaliotsLinearAlgebra'!

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 20:03'!
testAddToFloat

	| coeff |
	coeff := ((Polynomial coefficient: #(1 2 3 4)) addToFloat: 0.3) coefficient.

	self
		assert: (coeff at: 1) = 1;
		assert: (coeff at: 2) = 2;
		assert: (coeff at: 3) = 3;
		assert: (coeff at: 4) = 4.3
! !

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 20:05'!
testAddToFraction

	| coeff |
	coeff := ((Polynomial coefficient: #(1 2 3 4)) addToFraction: 3/4) coefficient.

	self
		assert: (coeff at: 1) = 1;
		assert: (coeff at: 2) = 2;
		assert: (coeff at: 3) = 3;
		assert: (coeff at: 4) = (4+(3/4))
! !

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 15:29'!
testAddToInteger

	| coeff |
	coeff := ((Polynomial coefficient: #(1 2 3 4)) addToInteger: 3) coefficient.

	self
		assert: (coeff at: 1) = 1;
		assert: (coeff at: 2) = 2;
		assert: (coeff at: 3) = 3;
		assert: (coeff at: 4) = 7
! !

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 20:08'!
testCoefficientOfOrder

	|pol|
	pol :=  Polynomial coefficient: #(1 -2 3).
	self assert: (pol coefficientOfOrder: 2) equals: 1.
	self assert: (pol coefficientOfOrder: 1) equals: -2.
	self assert: (pol coefficientOfOrder: 0) equals: 3.! !

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 20:09'!
testConstantTerm

	|pol|
	pol :=  Polynomial coefficient: #(1 -2 3).
	self assert: (pol constantTerm) equals: 3.
! !

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/30/2013 12:45'!
testFineRealRoots

	self assert: ( ((Polynomial roots: #(3)) fineRealRoots) includesAll: #(3) ).
	self assert: ( ((Polynomial roots: #(4 7)) fineRealRoots) includesAll: #(4 7) ).
	self assert: ( ((Polynomial roots: #(1 2 3)) fineRealRoots) includesAll: #(1 1.999999999999993 3) ).! !

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 9/10/2013 22:18'!
testLowestCoefficient

	self assert: ((Polynomial coefficient: {1}) lowestCoefficient) equals: 1.
	self assert: ((Polynomial coefficient: {1. 2}) lowestCoefficient) equals: 2.! !

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 15:37'!
testMinus

	self
		assert: (Polynomial coefficient: #(2 1)) - (Polynomial coefficient: #(1 2 1)) = (Polynomial coefficient: #(-1 0 0));
		assert: 5 - (Polynomial coefficient: #(1 2 1)) = (Polynomial coefficient: #(-1 -2 4));
		assert: (Polynomial coefficient: #(1 2 1)) - 5.0 = (Polynomial coefficient: #(1 2 -4.0))! !

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 16:57'!
testMultiply

	self assert: (Polynomial coefficient: #(1 -1)) * (Polynomial coefficient: #(2 1)) = (Polynomial coefficient: #(2 -1 -1))! !

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 18:19'!
testMultiplyAndAddition

	self assert: 
		(Polynomial roots: #(1 1)) coefficient asArray = #(1 -2 1)! !

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/30/2013 12:53'!
testMultiplyByInteger

	| coeff |
	coeff := ((Polynomial coefficient: #(1 -2 1)) multiplyByInteger: 4) coefficient.

	self 
		assert: (coeff at: 1) = 4;
		assert: (coeff at: 2) = -8;
		assert: (coeff at: 3) = 4! !

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 18:21'!
testMultiplyByNumber

	| coeff |
	coeff := ((Polynomial coefficient: #(1 -2 1)) * 4) coefficient.

	self 
		assert: (coeff at: 1) = 4;
		assert: (coeff at: 2) = -8;
		assert: (coeff at: 3) = 4! !

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/30/2013 12:54'!
testNegated

	self assert: (Polynomial coefficient: {1. 2. 3}) negated = (Polynomial coefficient: {-1. -2. -3}).! !

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 18:23'!
testPlus

	self
		assert: 
			(
				(Polynomial coefficient: #(1 2)) + 
				(Polynomial coefficient: #(2 -1))
			) = 
				(Polynomial coefficient: #(3 1));
		assert:
			(
				1.0 + 
				(Polynomial coefficient: #(2 -1))
			) = 
				(Polynomial coefficient: #(2 0));
		assert:
			(
				(Polynomial coefficient: #(2 -1))
				+
				1.0
			) = 
				(Polynomial coefficient: #(2 0))
! !

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 9/10/2013 22:21'!
testPowerSeries

	self assert: ((Polynomial coefficient: {1. -2. 3}) powerSeries: 5) equals: #(25 5 1)! !

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 9/10/2013 22:24'!
testRaisedTo

	self assert: ((Polynomial coefficient: {1. -2. 3}) raisedTo: 5) equals: (Polynomial coefficient: #(1 -10 55 -200 530 -1052 1590 -1800 1485 -810 243))! !

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 9/10/2013 22:27'!
testRemoveHighZeros

	self assert: ((Polynomial coefficient: {0. 0. 0. 0. 1. 2}) removeHighZeros) equals: (Polynomial coefficient: {1. 2})! !

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 18:26'!
testRootFinding

	self assert: ( (Polynomial roots: #(1 2 3)) roots includesAll: #(1 2 3) )! !

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 9/10/2013 22:33'!
testSubtractFromPolynomial

	self assert: ( (Polynomial coefficient: #(1 2 3)) subtractFromInteger: 100 ) equals: (Polynomial coefficient: #(-1 -2 97))! !
